%**********************************************************************;
% Project           : Iterative methods and preconditioning for large 
%			and sparse linear systems with applications
%
% Program name      : matrixspy.m
%
% Author            : F. Durastante -- fdurastante@uninsubria.it
%
% Date created      : 28 July 2017
%
% Purpose           : Spy and pattern of a sparse matrices.
%
% Revision History  :
%
% Date        Author      	Ref    Revision (Date in DD/MM/YYYY format) 
% 28/07/2017  F. Durastante     1      File Created
%
%**********************************************************************;


%% Matrix pattern
load('dwa512.mat');

figure(1)
A = Problem.A;
spy(A,'k');

figure(2)
e = ones(5,1);
A = spdiags([-e,2*e,-e],-1:1,5,5);
I = speye(size(A));
A = kron(I,A)+kron(A,I);

mesh(abs(inv(A)),'FaceLighting','gouraud','LineWidth',0.3)
axis([0 size(A,1) 0 size(A,2) 0 max(max(abs(inv(A))))])
colormap('gray');
colorbar
