%% COMPARING CG ALGORITHM AND ONE--DIMENSIONAL PROJECTION ALGORITHMS

clear;
clc;

R = 'S';    % Other possible shapes for the domain are S,N,C,D,A,H,B
            % Generate and display the grid.

symbol = {'o-', '*-', 'x-','s-','d-','^-','v-','>-','<-','p-','h-','+-'};
figure(1)
subplot(1,2,1);
hold all
for n = 10:5:30
    GRID = numgrid(R,n);
    A = delsq(GRID);
    N = sum(GRID(:)>0);
    b = ones(N,1);
    tic;
    [u,flag,relres,iter,res]  = pcg(A,b,1e-6,1000);
    time = toc;
    fprintf('%d & %d & %2.2e & %2.2e \\\\\n',...
        N,iter,relres,time);
    semilogy(1:iter+1,res(1:end),['k',symbol{mod(n,6)+1}],'DisplayName',...
        sprintf('N = %d',N));
    legend('-DynamicLegend','Location','eastoutside');
    set(gca,'YScale','log');
end
hold off

symbol = {'o-', '*-', 'x-','s-','d-','^-','v-','>-','<-','p-','h-','+-'};
figure(1)
subplot(1,2,2);
hold all
for n = 10:5:30
    GRID = numgrid(R,n);
    A = delsq(GRID);
    N = sum(GRID(:)>0);
    b = ones(N,1);
    tic;
    [u,flag,relres,iter,res]  = steepestdescent(A,b,1e-6,1000);
    time = toc;
    fprintf('%d & %d & %2.2e & %2.2e \\\\\n',...
        N,iter,relres,time);
    semilogy(1:50:iter,res(1:50:end),['k',symbol{mod(n,6)+1}],'DisplayName',...
        sprintf('N = %d',N));
    legend('-DynamicLegend','Location','eastoutside');
    set(gca,'YScale','log');
end
hold off