%% JACOBI METHOD APPLICATION - AN EXAMPLE

clear;
clc;

R = 'S';    % Other possible shapes for the domain are S,N,C,D,A,H,B
            % Generate and display the grid.

symbol = {'o-', '*-', 'x-','s-','d-','^-','v-','>-','<-','p-','h-','+-'};
figure(1)
clf
hold all
for n = 10:5:30
    GRID = numgrid(R,n);
    A = delsq(GRID);
    N = sum(GRID(:)>0);
    b = ones(N,1);
    tic;
    [u,flag,relres,iter,res]  = jacobi(A,b,1e-6,1000);
    time = toc;
    D = spdiags(diag(A),0,N,N);
    Dinv = spdiags(1./diag(A),0,N,N);
    G = Dinv*(D-A) ;
    fprintf('%d & %d & %2.2e & %2.2e & %1.3f \\\\\n',...
        N,iter,relres,time,max(abs(eig(G))));
    semilogy(1:50:iter,res(1:50:end),symbol{mod(n,6)+1},'DisplayName',...
        sprintf('N = %d',N));
    legend('-DynamicLegend','Location','eastoutside');
    set(gca,'YScale','log');
end
hold off