%% TESTING THE SOLUTION OF SOME LINEAR SYSTEM WITH GMRES AND ITS VARIANTS
clear;
clc;

addpath('./testmatrix/');

% Problem 1:
load('ex20.mat');
A = Problem.A;
maxA = max(max(abs(A)));
A = A./maxA;
n = size(A,1);
e = ones(n,1);
b = A*e;
fprintf('%s\n',Problem.title);
fprintf('Problem size: %d, nnz(A) = %d\n',n,nnz(A));

tol = 1e-6;
maxit = n;
fprintf('GMRES:\n');
[x,~,~,~,resgmres] = gmres(A,b,[],tol,maxit);
fprintf('GMRES(20):\n');
[x,~,~,~,resgmres20] = gmres(A,b,20,tol,maxit);
fprintf('GMRES(10):\n');
[x,~,~,~,resgmres10] = gmres(A,b,10,tol,maxit);
fprintf('FGMRES+GMRES(20):\n');
[x,resfgmres,its] = fgmres(A,b,maxit,maxit,tol,20,1e-6,100);
fprintf('FGMRES+GMRES(10):\n');
[x,resfgmres2,its] = fgmres(A,b,maxit,maxit,tol,10,1e-6,100);

figure(1)
loglog(1:(length(resgmres)),resgmres,'kx-',...
    1:(length(resgmres20)),resgmres20,'ks-',...
    1:(length(resgmres10)),resgmres10,'kd-',...
    1:(length(resfgmres)),resfgmres,'ko-',...
    1:(length(resfgmres2)),resfgmres2,'k.-');
xlabel('Iteration')
ylabel('Residual')
legend('GMRES','GMRES(20)','GMRES(10)','FGMRES+GMRES(20)',...
    'FGMRES+GMRES(10)')