verbosity=0;
int p=2,q=3;
real t=0;
int factor=4;
int nn=10*factor;
mesh Th=square(nn,nn);
fespace Xh(Th,P2);
Xh uh,vh;
real Tfin=5, t0=0.;
real dt=1.0/nn;
real r,drdt,errL2sq=0.0,errH1sq=0.0,errLiL2=0.0,errL2H1=0.0,locL2=0.0,locH1=0.0;
Xh Phi=cos(p*x)*sin(q*y);
t=t0;
r=t^3-50;
Xh uhold0=r*Phi;
r=t^3-50;
Xh uhold1=r*Phi;

Xh fh;
Xh bdata;

problem parabolicbdf2(uh,vh) =int2d(Th)(uh*vh/dt-(2.0/3.0)*(p^2+q^2)*uh*vh+
                               (2.0/3.0)*(dx(uh)*dx(vh)+dy(uh)*dy(vh))
                                   )
                       - int2d(Th)((2.0/3.0)*fh*vh+((4.0/3)*uhold1-(1.0/3)*uhold0)*vh/dt)
                       +on(1,2,3,4,uh=bdata);
for (t=t0+2*dt;t<=Tfin;t+=dt)
{
r=t^3-50;
drdt=3*t^2;
fh=drdt*Phi;
bdata=r*Phi;
parabolicbdf2;
Xh uexh=r*Phi;
Xh dxuexh=-p*r*sin(p*x)*sin(q*y);
Xh dyuexh=q*r*cos(p*x)*cos(q*y);
plot(cmm="Time level "+t,uh,dim=3,fill=1,wait=0,value=1);
locL2=int2d(Th)((uh-uexh)^2);
locH1=locL2+int2d(Th)((dx(uh)-dxuexh)^2)+int2d(Th)((dy(uh)-dyuexh)^2);
errL2sq=max(errL2sq,locL2);
errH1sq=errH1sq+dt*locH1;
uhold0=uhold1;
uhold1=uh;
}
errLiL2 = sqrt(errL2sq);
errL2H1 = sqrt(errH1sq);
cout << "Using BDF(2) and (p,q) = " << p<<" "<<q<<endl;
cout << "Errors at time  T = " << Tfin<<"  using dt=dh = " << dt << endl;
cout << "Errors : Linfty(L2) " << errLiL2 << "  L2(H1)  " << errL2H1 << endl;
