clear;
clc;

load('sherman4');
A = Problem.A;
b = Problem.b;

% Solution
restart = [];
tol = 1e-6;
maxit = size(A,1);
delta = [1e-1,1e-2,1e-3,1e-4,1e-5];
opts.type = 'ilutp';
for i=0:4
    tic;
    opts.droptol=delta(i+1);
    [L,U] = ilu(A,opts);
    tlu = toc;
    tic;
    [~,~,~,iter] = gmres(A,b,restart,tol,maxit,L,U);
    tsol=toc;
    fprintf('ILUT(%1.1e) & %1.2e & %d & %d & %1.2e \\\\\n',...
        delta(i+1),tlu,iter(1),iter(2),tsol);
end
tic;
[~,~,~,iter] = gmres(A,b,restart,tol,maxit);
tsol=toc;
fprintf(' & & %d & %d & %1.2e \\\\\n',...
            iter(1),iter(2),tsol);
% Pattern of the Factors
j = 2;
subplot(3,2,1);
spy(A,'k');
title(Problem.name,'interpreter','LaTeX');
figure(1);
for i= 0:4
    opts.droptol=delta(i+1);
    [L,U] = ilu(A,opts);
    subplot(3,2,j);
    spy(L,'k');
    title(['L ($\varepsilon',sprintf(' = %1.1e',delta(i+1)),')$'],'interpreter','LaTeX');
    j = j + 1;
end