%% TEST FOR THE CONSTRUCTION OF THE JACKSON KERNEL
% Probabilmente non incluso nel libro definitivo

clear;
clc;

tt = linspace(-pi,pi,1000);
n = 512;
t = toepgenerator(n,8);
t1 = conj(t(n:-1:2)); 

%% K_{m,2}(theta)
r = 1;
m = ceil(n/r);

k = [-(m-1):0,1:(m-1)];
b = (m - abs(k))/m;
f = @(theta) sum(b.*exp( 1i*k*theta));
for i=1:length(tt)
    y1(i) = real(f(tt(i)));
end

coef = [b(1:r*m),b(end:-1:(r*m-1))];
c1 = [t(1)*coef(1) coef(2:n).*t(2:n)+coef(n:-1:2).*t1];

%% K_{m,4}(theta)
r = 2;
m = ceil(n/r);

k = [-(m-1):0,1:(m-1)];
b = (m - abs(k))/m;
b = conv(b,b);
k = [(-r*m + r):0,1:(r*m-r)];
f = @(theta) sum(b.*exp( 1i*k*theta));

tt = linspace(-pi,pi,1000);
for i=1:length(tt)
    y2(i) = real(f(tt(i)));
end

coef = [b(1:r*m),b(end:-1:(r*m-1))];
c2 = [t(1)*coef(1) coef(2:n).*t(2:n)+coef(n:-1:2).*t1];

%% K_{m,6}(theta)
r = 3;
m = ceil(n/r);

k = [-(m-1):0,1:(m-1)];
b = (m - abs(k))/m;
b = conv(b,conv(b,b));
k = [(-r*m + r):0,1:(r*m-r)];
f = @(theta) sum(b.*exp( 1i*k*theta));

coef = [b(1:r*m),b(end:-1:(r*m-1))];
c3 = [t(1)*coef(1) coef(2:n).*t(2:n)+coef(n:-1:2).*t1];

tt = linspace(-pi,pi,1000);
for i=1:length(tt)
    y3(i) = real(f(tt(i)));
end

figure(1);
plot(tt,y1,'r-',tt,y2,'b-',tt,y3,'k-');
h = legend('$K_{m,2}(\theta)$','$K_{m,4}(\theta)$','$K_{m,6}(\theta)$');
set(h,'Interpreter','latex');
axis tight
xticks(-pi:pi/2:pi)
xticklabels({'-\pi','-\pi/2','0','\pi/2','\pi'})

figure(2)
semilogx(eig(toeplitz(t)),0.1,'k+',eig(cprec(c1,toeplitz(t))),0.2,'k+',...
    eig(cprec(c2,toeplitz(t))),0.3,'k+',...
    eig(cprec(c3,toeplitz(t))),0.4,'k+')
axis([1e-6 1e6 0 0.5])