function [ y ] = ocircsol( W,omega,v )
%OCIRCSOL Solves the linear system Wy=v with FFTs for W an omega circulan
%matrix
%   W is the omega-circulant matrix or its eigenvalues
%   omega is the values for which W is an omega-circulant matrix
%   v is the right-hand side of the linear system

n = size(W,1);
O = omega.^(0:-1/n:-(n-1)/n)';

if ismatrix(W)
    eig = fft(O.*W(1:end,1));
else
    eig = W(1:end)';
end

y = ifft(fft(v./conj(O))./eig)./O;

if norm(imag(y))<1e-10
    y = real(y);
end

end

