function [ y ] = realprod( A,B,x,type )
%REALPROD Compute the product M_type * x = y for M_type one of the
%equivalent real formulation of the complex matrix C = A + iB, see Table
%4.5 in the book
%   A real part of the matrix C
%   B imaginary part of the matrix C
%   vector to be multiplyed
%   type of the rewriting;

n = length(A);
x1 = x(1:n);
x2 = x(n+1:end);

if type == 1
    y1 = A*x1 - B*x2;
    y2 = B*x1 + A*x2;
elseif type == 2
    y1 = A*x1 + B*x2;
    y2 = B*x1 - A*x2;
elseif type == 3
    y1 = B*x1 + A*x2;
    y2 = A*x1 - B*x2;
elseif type == 4
    y1 = B*x1 - A*x2;
    y2 = A*x1 + B*x2;
else
    error('Unrecognized type: type = 1,2,3,4.');
end

y = [y1;y2];

end

