%% TEST FOR THE STOKES PROBLEM WITH UZAWA METHOD

%% Clean the workspace
clear;
clc;
close all

%% Load some routine to work with FreeFem++
addpath('./freefemtomatlab/');
addpath('./auxiliaryfunction/');

%% Execute the FreeFem++ Code (The computation is done here!)
!FreeFem++ StokesUzawa.edp

%% Acquire the matrices from the discretization
A = FFmatrix_fread('Astokuz.dat');
B = FFmatrix_fread('Bstokuz.dat');
Bt = FFmatrix_fread('BTstokuz.dat');
M = [A,Bt';B,sparse(size(B,1),size(B,1))];

spy(M,'k');
hline(size(A,1),'k--');
vline(size(A,2),'k--');
axis square