%% TEST THE MATRIX-VECTOR PRODUCT FOR CIRCULANT AND TOEPLITZ MATRIX
clear;
clc;
repeat = 20;

for k = 5:14
    n = 2^k;
    e = rand(n,1);
    x = ones(n,1);
    C = gallery('circul',e);
    tic
    for l=1:repeat
        C*x;
    end
    tfull(k-4) = toc/repeat;
    tic
    for l=1:repeat
        circmv(C,x);
    end
    tfft(k-4) = toc/repeat;
end

N = 2.^(5:14);
loglog(N,tfull,'ko',...
    N,tfft,'k*');
legend('Full Product','FFT product');