clear;
clc;

%% Distribution of the eigenvalues for a Symmetric Toeplitz Matrix
n = 100;
e = ones(n,1);
Tn = spdiags([-e,2*e,-e],-1:1,n,n);
lambdan = eig(Tn);
x=linspace(0,2*pi,n);

figure(1)
plot(x,2 - 2*cos(x/2),'k-',x,lambdan,'ko');
axis([0,2*pi,0,4]);
set(groot, 'defaultAxesTickLabelInterpreter','latex'); 
set(groot, 'defaultLegendInterpreter','latex');
set(gca,'xtick',[0 pi/2 pi 3*pi/2 2*pi]); 
set(gca,'xticklabel',{'0','$\frac{\pi}{2}$','$\pi$','$\frac{3\pi}{2}$','$2\pi$'});
set(gca,'FontSize',12);
legend('Distribution Function','Computed Eigenvalues','Location','NorthWest');