function [x] = mgm(A,b,x,a,omega1,omega2,gamma,v1,v2,liv,m)
%MGM Un ciclo di multigrid per Ax = b
%   a = maschera del proiettore
%   omega = parametro rillasamento di jacobi
%   v1 = iterazioni pre-smoother
%   v2 = iterazioni post-smoother
%   liv = livello corrente
%   m = numero di livelli - 1


if liv == m
    x = A\b;
    %[x,~] = bicgstab(A,b);
else
    n = length(b); % dimensione al livello corrente
    x = jacobi(A,b,x,omega1,v1); %Pre-smoother
    r = b - A*x; %Residuo
    P = proiettore( a,n ); % residuo al livello corrente
    r = P'*r; % proietto il residuo
    B = P'*A*P;
    e = zeros(size(r)); % inizializzo errore sulla grigia
    for i = 1:gamma
        e = mgm(B,r,e,a,omega1,omega2,gamma,v1,v2,liv+1,m);
    end
    x = x + P*e;
    x = jacobi(A,b,x,omega2,v2); %Post-smoother
end

