function [ x,err ] ...
    = mgm_main( A,b,x,numiter,tol,a,v1,v2,omega1,omega2,gamma,xtrue )
%MGM_MAIN Risolve Ax = b con il multigrid V-cycle gamma chiamate
%ricorsive e Jacobi pesato con parametro omega come smoother
%   Ax = b sistema lineare da risolvere
%   numiter massimo numero di iterazioni
%   tol tolleranza
%   a proiettore
%   omega parametro di rillasamento di Jacobi
%   gamma numero di chiamate ricorsive
%   xtrue soluzione vera

% SETUP DELLE MATRICI DI LIVELLO %

m = fix(log2(length(x)))-1; %Numero di livelli - 1,i.e., m = 1 TGM
%m = 1;
tol = tol*norm(b);

for i = 1:numiter
    x = mgm(A,b,x,a,omega1,omega2,gamma,v1,v2,0,m);
    r = b-A*x;
    err(i) = norm(x - xtrue);
    if norm(r)<tol
        break
    end
end

err = err/norm(xtrue); %calcolo residuo relativo;

end

