function [ P ] = proiettore( a,n )
%PROIETTORE P = T*K', dove K è la matrice di downsampling e T è
%la matrice di Toepliz costruita a partire dai coefficienti non
% nulli di a.
%   a = vettore dei coefficienti diversi da zero della matrice
%   n = dimensione della matrice di proiezione
if mod(n,2) == 0
    error('n deve essere dispari!')
end
t = zeros(n,1);
t(1:length(a))=a(:);
T = toeplitz(t);
P = sparse(T(:,2:2:end-1)); % T*K', abbiamo tagliato le colonne
                            % di indice dispari mantenendo
                            % quelle di indice pari
end

